BuildRequires: hsqldb
BuildRequires: /proc
BuildRequires: jpackage-1.5-compat
# Copyright (c) 2000-2005, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define hname hibernate-annotations

Summary:        Relational persistence and query service
Name:           hibernate3-annotations
Version:        3.2.0
Release:        alt1_0.cr1.2jpp5.0
Epoch:          0
License:        LGPL
URL:            http://annotations.hibernate.org/
Group:          Databases
Source0:        http://prdownloads.sourceforge.net/hibernate/hibernate-annotations-3.2.0.CR1.tar.gz
Source1:	hibernate-annotations-jdstyle.css

Patch0:         hibernate-annotations-common-build_xml.patch


BuildRequires: jpackage-utils >= 0:1.6
BuildRequires: ant >= 0:1.6
BuildRequires: antlr
BuildRequires: cglib
BuildRequires: dom4j
BuildRequires: geronimo-jta-1.0.1B-api
BuildRequires: jakarta-commons-logging
BuildRequires: jakarta-commons-collections
BuildRequires: javassist
BuildRequires: hibernate3 >= 0:3.2
BuildRequires: hibernate3-ejb-persistence-3.0-api
BuildRequires: lucene1

Requires: hibernate3 >= 0:3.2
Requires: hibernate3-ejb-persistence-3.0-api
Requires: lucene1
BuildArch:      noarch

%description
Hibernate, like all other object/relational mapping tools, 
requires metadata that governs the transformation of data 
from one representation to the other (and vice versa). In 
Hibernate 2.x, mapping metadata is most of the time declared 
in XML text files. Another option is XDoclet, utilizing 
Javadoc source code annotations and a preprocessor at compile 
time.
The same kind of annotation support is now available in the 
standard JDK, although more powerful and better supported by 
tools. IntelliJ IDEA, for example, supports auto-completion 
and syntax highlighting of JDK 5.0 annotations. The EJB3 
specification standardizes the basic APIs and the metadata 
(using JDK 5.0 annotations) needed for any object/relational 
persistence mechanism. Hibernate EntityManager for EJB3 
implements the programming interfaces and lifecycle rules as 
defined by the EJB3 persistence specification. Both Hibernate 
EntityManager and Hibernate Annotations are available in 
standalone preview releases, however, they require Hibernate 
3.1 and JDK 5.0. If you are not using EJB3 persistence, 
please continue using Hibernate 3.0.x (with any JDK supported).
The Hibernate Annotations package provides annotations for
Standard JSR-220 defined O/R mapping
Hibernate O/R mapping extensions
Data validation via the Hibernate Validator framework

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q -n %{hname}-%{version}.CR1
# remove all binary libs
for j in $(find . -name "*.jar"); do
	mv $j $j.no
done
mkdir test_output
cp %{SOURCE1} doc/api/jdstyle.css


%patch0 -b .sav

%build
export JAVA_HOME=/usr/lib/jvm/java-1.5.0
build-jar-repository -s -p . \
hibernate3

build-jar-repository -s -p lib \
antlr \
cglib-nodep \
commons-collections \
commons-logging \
dom4j \
hibernate3 \
hibernate3-ejb-persistence-3.0-api \
javassist \
jta \
lucene \

mkdir jdbc
build-jar-repository -s -p jdbc hsqldb

ant \
	-Dhibernate-core.home=. \
	-Djdk15.home=/usr/lib/jvm/java-1.5.0 \
	jar javadoc junitinstrument junit

%install

# jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}

cp -p target/%{hname}/%{hname}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

## javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr doc/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

# manual
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p lgpl.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%doc %{_docdir}/%{name}-%{version}/lgpl.txt
%{_javadir}/*.jar

%files javadoc
%{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}


%changelog
* Wed Jan 23 2008 Igor Vlasenko <viy@altlinux.ru> 0:3.2.0-alt1_0.cr1.2jpp5.0
nobootstrap build

